mod tokenizer;
use tokenizer::*;

mod parser;
use parser::*;

mod executor;
use executor::*;

fn main() -> Result<(), Box<dyn std::error::Error>> {
    let source = std::fs::read_to_string("src/test.lisp").unwrap();

    let mut tokenizer = Tokenizer::new(source);
	let tokens = tokenizer.tokenize()?;
	let mut parser = Parser::new(tokens);
	let instructions = parser.parse();

	let mut state = LispState::new();

	let mut some_map = std::collections::HashMap::new();
	some_map.insert(String::from("x"), LispValue::Float(0.0));
	some_map.insert(String::from("y"), LispValue::Float(0.0));

	state.execute(instructions)?;

	let f = state.get_func("takevalue").unwrap();

	state.call_lisp_func(&f, vec![LispValue::Map(some_map)])?;

	Ok(())
}
